SystemOrganization addCategory: #Deprecated14!

!PasteUpMorph methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/31/2011 14:20'!
findATranscript: evt
	self deprecated: 'Pharo1.3. Use Smalltalk tools openTranscript' on: '27 May 2011' in: 'Pharo1.3'.
	Smalltalk tools openTranscript! !

!UIManager methodsFor: '*Deprecated14' stamp: 'StephaneDucasse 9/7/2011 21:26'!
multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: answerHeight
	"Create a multi-line instance of me whose question is queryString with
	the given initial answer. Invoke it centered at the given point, and
	answer the string the user accepts.  Answer nil if the user cancels.  An
	empty string returned means that the ussr cleared the editing area and
	then hit 'accept'.  Because multiple lines are invited, we ask that the user
	use the ENTER key, or (in morphic anyway) hit the 'accept' button, to 
	submit; that way, the return key can be typed to move to the next line."
	
	self deprecated: 'Use multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: ' on: '7 September 2011' in: 'Pharo1.4'.
	^self subclassResponsibility! !

ContextPart variableSubclass: #BlockContext
	instanceVariableNames: 'nargs startpc home'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!BlockContext commentStamp: 'MarcusDenker 10/21/2011 16:51' prior: 0!
Deprecated, not used. See BlockClosure instead!

!ThemeSettings methodsFor: '*Deprecated14' stamp: 'AlainPlantec 11/6/2011 13:17'!
menuWithIcons
	^ true! !

!ThemeSettings methodsFor: '*Deprecated14' stamp: 'AlainPlantec 11/6/2011 13:17'!
menuWithIcons: aBoolean
	"menuWithIcons := aBoolean"! !

!StrikeFont class methodsFor: '*deprecated14' stamp: 'AlainPlantec 12/18/2009 07:23'!
accunyKey 
	^ #Accuny! !

!StrikeFont class methodsFor: '*deprecated14' stamp: 'HenrikSperreJohansen 1/11/2010 23:23'!
createDejaVu: pointSize
	"Warning: Uses the methods in 'dejaVu font data' category, that will be removed soon (or are already removed) to save space."
	
	| base bold oblique boldOblique point |
	point := pointSize asString.
	base := (StrikeFont new
		buildFromForm: (self perform: ('dejaVuSansBook', point, 'Form') asSymbol)
		data: (self perform: ('dejaVuSansBook', point, 'Data') asSymbol)
		name: 'Bitmap DejaVu Sans ', point)
			pointSize: pointSize.
	bold := (StrikeFont new
		buildFromForm:  (self perform: ('dejaVuSansBold', point, 'Form') asSymbol)
		data: (self perform: ('dejaVuSansBold', point, 'Data') asSymbol)
		name: 'Bitmap DejaVu Sans ', point, 'B')
			emphasis: 1;
			pointSize: pointSize.
	oblique := (StrikeFont new
		buildFromForm: (self perform: ('dejaVuSansOblique', point, 'Form') asSymbol)
		data: (self perform: ('dejaVuSansOblique', point, 'Data') asSymbol)
		name: 'Bitmap DejaVu Sans ', point, 'I')
			emphasis: 2;
			pointSize: pointSize.
	boldOblique := (StrikeFont new
		buildFromForm: (self perform: ('dejaVuSansBoldOblique', point, 'Form') asSymbol)
		data: (self perform: ('dejaVuSansBoldOblique', point, 'Data') asSymbol)
		name: 'Bitmap DejaVu Sans ', point, 'BI')
			emphasis: 3;
			pointSize: pointSize.
		
	base derivativeFont: bold at: 1.
	base derivativeFont: oblique at: 2.
	base derivativeFont: boldOblique at: 3.
	bold derivativeFont: boldOblique at: 2.
	oblique derivativeFont: boldOblique at: 1. 
	
	^base! !

!StrikeFont class methodsFor: '*deprecated14' stamp: 'AlainPlantec 9/12/2011 19:01'!
installDejaVu
	"
	StrikeFont installDejaVu
	"
	StandardFonts restoreDefaultFonts.
	StrikeFont useUnderscoreIfOver1bpp! !

Paragraph subclass: #NewParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!NewParagraph commentStamp: '<historical>' prior: 0!
A Paragraph represents text that has been laid out, or composed, in some container.
	text 		A Text with encoded per-character emphasis.
	textStyle	A TextStyle with font set, line height and horizontal alignment.
	firstCharacterIndex    The starting index in text for this paragraph, allowing
				composition of a long text into a number of containers.
	container	A Rectangle or TextContainer that determines where text can go.
	lines		An Array of TextLines comprising the final layout of the text
				after it has been composed within its container.
	positionWhenComposed   As its name implies.  Allows display at new locations
				without the need to recompose the text.
Lines are ordered vertically.  However, for a given y, there may be several lines in left to right order.  Lines must never be empty, even if text is empty.

Notes on yet another hack - 5 Feb 2001

We really need to clean up #composeLinesFrom:to:delta:into:priorLines:atY:!!!!!!

I added one more habdful of code to correct:

This is an annoying bug that's been around for a couple of years, but I finally figured out how to duplicate the problem, so I figured I'd just report it now.  (It doesn't necessarily have to be fixed for 3.0 if it looks messy, but if it's a simple fix, it would be worth it.)

In Morphic, if you have the following text in a workspace:

This is line 1
This is line 2

**and** you have a return character after line 2, you will normally be able to click the mouse two times below line 2 in order to select all the text.  If you edit line 2 (e.g. so that it reads "line number 2"), you can still select all the text by clicking below the second line.  However, if you edit line 1, you will not be able to select all the text from the bottom in the same way.  Things get messed up such that the last return character seems to be gone.  In this state, if you position the cursor immediately after the 2, and press the right arrow, the cursor jumps to the beginning of line 2... oof. (report by Doug Way)

While I don't have a very deep understanding of the above mentioned method, I was able to determine that text ending in a CR worked better in the editor when the last entry in <lines> had a start of text size + 1 and a stop of text size. I have accordingly added code near the end to ensure this. It seems to have fixed the problem, but we do need to clean this baby up some day. - Bob
!

NewParagraph subclass: #MultiNewParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!MultiNewParagraph commentStamp: 'LaurentLaffont 6/8/2011 22:21' prior: 0!
Class intention
   My intention is the same as my super class. This is a good reason to merge me with my super class and to remove me.
   My main supplementary intention is to display the different kinds of text selection (secondary, find-replace and selection bar).

Class collaborations
   SelectionBlock instances are built by myself and stored in the extraSelectionBlocks instance variable in order to display supplementary selections

Class main API
   no particular main API.


Instance Variables
   extraSelectionBlocks: <Collection of SelectionBlock>
   findReplaceSelectionRegex: <RxMatcher>
   presentationLines: <Object>
   presentationText: <Object>
   refreshExtraSelection: <Boolean>
   secondarySelection: <String>

extraSelectionBlocks
   - a collection of SelectionBlock for the drowing of the differents kind of text selection

findReplaceSelectionRegex
   - the find/replace matcher that is set from the editor of by the FindReplaceService

presentationLines
   - created for debugging purpose, should be removed ?

presentationText
   - created for debugging purpose, should be removed ?

refreshExtraSelection
   - a boolean that is set to tru when there is a need to refresh selections

secondarySelection
   - the string of the secondary selection that is set from the editor when a portion of text is selected!

!MultiNewParagraph methodsFor: 'debug' stamp: 'AlainPlantec 9/15/2011 15:27'!
displayOnTest: aCanvas using: displayScanner at: somePosition
	"Send all visible lines to the displayScanner for display"

	| visibleRectangle offset leftInRun line |
	"(presentationText isNil or: [presentationLines isNil]) ifTrue: [
		^ self displayOn: aCanvas using: displayScanner at: somePosition.
	]."
	visibleRectangle := aCanvas clipRect.
	offset := somePosition - positionWhenComposed.
	leftInRun := 0.
	(self lineIndexForPoint: visibleRectangle topLeft)
		to: (self lineIndexForPoint: visibleRectangle bottomRight)
		do: [:i | line := self presentationLines at: i.
			self displaySelectionInLine: line on: aCanvas.
			line first <= line last ifTrue:
				[leftInRun := displayScanner displayLine: line
								offset: offset leftInRun: leftInRun]].
! !

!MultiNewParagraph methodsFor: '*deprecated14' stamp: 'AlainPlantec 9/15/2011 13:52'!
presentationLines
	^ self composer presentationLines! !

!MultiNewParagraph methodsFor: '*deprecated14' stamp: 'AlainPlantec 9/15/2011 13:54'!
presentationText
	^ self composer presentation! !

AppRegistry subclass: #MorphicTextEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!MorphicTextEditor commentStamp: 'StephaneDucasse 6/1/2011 19:56' prior: 0!
Deprecated in 1.3 

Do not refer to this class!

ImageMorph subclass: #LogoImageMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

LogoImageMorph class
	instanceVariableNames: 'default'!

!LogoImageMorph commentStamp: 'AlainPlantec 9/11/2011 08:04' prior: 0!
Deprecated in 1.4 since we have a setting for the logo
!

LogoImageMorph class
	instanceVariableNames: 'default'!

!LogoImageMorph class methodsFor: 'defaultinstance' stamp: 'AlainPlantec 9/11/2011 08:33'!
default
	^default! !

!LogoImageMorph class methodsFor: 'defaultinstance' stamp: 'AlainPlantec 4/13/2010 13:34'!
default: newImageMorph
	default ifNotNil: [default delete].
	default := newImageMorph.
	default  ifNotNil: [
		default 
			openInWorld;
			beSticky;
			lock;
			goBehind]! !

!LogoImageMorph class methodsFor: 'defaultinstance' stamp: 'AlainPlantec 4/13/2010 13:01'!
defaultLogoForm
	^ Form fromBinaryStream: self defaultLogoContents base64Decoded asByteArray readStream! !

!LogoImageMorph class methodsFor: 'defaultinstance' stamp: 'AlainPlantec 9/11/2011 08:33'!
initialize
	default 
		ifNotNil: [self installDesktopLogo]! !

!LogoImageMorph class methodsFor: 'defaultinstance' stamp: 'AlainPlantec 9/11/2011 08:32'!
installDesktopLogo
	"Install the new logo with the settings"
	"self installDesktopLogo"
	default 
		ifNotNil: [default delete. 
		default := nil.
		PolymorphSystemSettings showDesktopLogo: true]
! !

BorderedMorph subclass: #BorderedSubpaneDividerMorph
	instanceVariableNames: 'resizingEdge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!BorderedSubpaneDividerMorph class methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 2/26/2012 12:44'!
forBottomEdge
	self  deprecated: 'dead code' on: '26 February 2012' in: 'Pharo1.4'.
	^self new horizontal resizingEdge: #bottom! !

!BorderedSubpaneDividerMorph class methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 2/26/2012 12:44'!
forTopEdge
	self  deprecated: 'dead code' on: '26 February 2012' in: 'Pharo1.4'.
	^self new horizontal resizingEdge: #top! !

!BorderedSubpaneDividerMorph class methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 2/26/2012 12:44'!
horizontal
	self  deprecated: 'dead code' on: '26 February 2012' in: 'Pharo1.4'.
	^self new horizontal! !

!BorderedSubpaneDividerMorph class methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 2/26/2012 12:44'!
vertical
	self  deprecated: 'dead code' on: '26 February 2012' in: 'Pharo1.4'.
	^self new vertical! !

!BorderedSubpaneDividerMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:09'!
defaultBorderWidth
"answer the default border width for the receiver"
	^ 0! !

!BorderedSubpaneDividerMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:09'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color black! !

!BorderedSubpaneDividerMorph methodsFor: 'as yet unclassified' stamp: 'ar 8/15/2001 23:24'!
firstEnter: evt
	"The first time this divider is activated, find its window and redirect further interaction there."
	| window |

	window := self firstOwnerSuchThat: [:m | m respondsTo: #secondaryPaneTransition:divider:].
	window ifNil: [ self suspendEventHandler. ^ self ]. "not working out"
	window secondaryPaneTransition: evt divider: self.
	self on: #mouseEnter send: #secondaryPaneTransition:divider: to: window.
! !

!BorderedSubpaneDividerMorph methodsFor: 'as yet unclassified' stamp: 'ar 8/15/2001 23:24'!
horizontal

	self hResizing: #spaceFill.! !

!BorderedSubpaneDividerMorph methodsFor: 'initialization' stamp: 'MarcusDenker 12/11/2009 23:56'!
initialize
	"initialize the state of the receiver"
	super initialize.
	self extent: 1@1! !

!BorderedSubpaneDividerMorph methodsFor: 'as yet unclassified' stamp: 'ar 8/15/2001 23:24'!
resizingEdge

	^resizingEdge
! !

!BorderedSubpaneDividerMorph methodsFor: 'as yet unclassified' stamp: 'ar 8/15/2001 23:24'!
resizingEdge: edgeSymbol

	(#(top bottom) includes: edgeSymbol) ifFalse:
		[ self error: 'resizingEdge must be #top or #bottom' ].
	resizingEdge := edgeSymbol.
	self on: #mouseEnter send: #firstEnter: to: self.
! !

!BorderedSubpaneDividerMorph methodsFor: 'as yet unclassified' stamp: 'ar 8/15/2001 23:24'!
vertical

	self vResizing: #spaceFill.! !

BorderedMorph subclass: #TTSampleFontMorph
	instanceVariableNames: 'font transform smoothing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!TTSampleFontMorph commentStamp: '<historical>' prior: 0!
An example for using TrueType fonts.!

!TTSampleFontMorph class methodsFor: 'instance creation' stamp: 'MarcusDenker 2/29/2012 13:12'!
font: aTTFontDescription
	self  deprecated: 'dead code' on: '29 February 2012' in: 'Pharo1.4'.
	^self new font: aTTFontDescription! !

!TTSampleFontMorph class methodsFor: 'connectors' stamp: 'MarcusDenker 2/29/2012 13:12'!
fontWithoutString: aTTFontDescription
	self  deprecated: 'dead code' on: '29 February 2012' in: 'Pharo1.4'.
	^self new fontWithoutString: aTTFontDescription! !

!TTSampleFontMorph methodsFor: 'menus' stamp: 'ar 6/16/1999 07:21'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addUpdating: #getSmoothingLevel action: #nextSmoothingLevel.! !

!TTSampleFontMorph methodsFor: 'halos and balloon help' stamp: 'sw 1/27/2000 15:43'!
addOptionalHandlesTo: aHalo box: box
	aHalo addHandleAt: box center color: Color magenta icon: nil on: #mouseDown send: #createSample to: self.! !

!TTSampleFontMorph methodsFor: 'drawing' stamp: 'ar 11/14/1998 23:12'!
areasRemainingToFill: aRectangle
	^ Array with: aRectangle! !

!TTSampleFontMorph methodsFor: 'halos and balloon help' stamp: 'ar 11/14/1998 23:39'!
balloonHelpTextForHandle: aHandle
	aHandle eventHandler firstMouseSelector == #createSample
		ifTrue:[^'Create a sample string'].
	^super balloonHelpTextForHandle: aHandle! !

!TTSampleFontMorph methodsFor: 'testing' stamp: 'ar 8/25/2001 19:09'!
canDrawBorder: aBorderStyle
	^aBorderStyle style == #simple! !

!TTSampleFontMorph methodsFor: 'updating' stamp: 'sma 1/1/2000 17:59'!
changed
	self invalidRect: (self fullBounds expandBy: 1)! !

!TTSampleFontMorph methodsFor: 'private' stamp: 'ar 11/15/1998 22:48'!
computeTransform
	| fullExtent scale |
	fullExtent := font bounds extent * 16.
	scale := self extent asFloatPoint / fullExtent asFloatPoint.
	transform := MatrixTransform2x3 withScale: scale.
	transform := transform composedWithGlobal: (MatrixTransform2x3 withOffset: self position).
	^transform! !

!TTSampleFontMorph methodsFor: 'menu' stamp: 'ar 11/14/1998 23:46'!
createSample
	self world primaryHand attachMorph: (TTSampleStringMorph font: font)! !

!TTSampleFontMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:40'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!TTSampleFontMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:31'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color black! !

!TTSampleFontMorph methodsFor: 'accessing' stamp: 'ar 11/14/1998 22:52'!
doesBevels
	^false! !

!TTSampleFontMorph methodsFor: 'drawing' stamp: 'lr 3/7/2010 12:05'!
drawCharactersOn: aCanvas
	| glyph origin r offset cy m |
	0 to: 255 do: [ :i | 
		glyph := font at: i.
		origin := font bounds extent * ((i \\ 16) @ (i // 16)).
		r := origin extent: font bounds extent.
		offset := r center - glyph bounds center.
		cy := glyph bounds center y.
		m := MatrixTransform2x3 withOffset: 0 @ cy.
		m := m composedWithLocal: (MatrixTransform2x3 withScale: 1 @ -1).
		m := m composedWithLocal: (MatrixTransform2x3 withOffset: 0 @ cy negated).
		m := m composedWithGlobal: (MatrixTransform2x3 withOffset: offset).
		aCanvas asBalloonCanvas
			preserveStateDuring: [ :balloonCanvas | 
				balloonCanvas transformBy: m.
				balloonCanvas
					drawGeneralBezierShape: glyph contours
					color: color
					borderWidth: 0
					borderColor: Color black ] ]! !

!TTSampleFontMorph methodsFor: 'drawing' stamp: 'ar 12/30/1998 10:49'!
drawOn: aCanvas
	| origin extent offset |
	(font isNil) 
		ifTrue:[^aCanvas frameRectangle: bounds color: Color black].
	origin := self position asIntegerPoint.
	extent := self extent asIntegerPoint.
	0 to: 16 do:[:i|
		offset := (extent x * i // 16) @ (extent y * i // 16).
		aCanvas line: origin x @ (origin y + offset y) 
				to: (origin x + extent x) @ (origin y + offset y)
				width: borderWidth color: borderColor.
		aCanvas line: (origin x + offset x) @ origin y 
				to: (origin x + offset x) @ (origin y + extent y)
				width: borderWidth color: borderColor.
	].
	aCanvas asBalloonCanvas preserveStateDuring:[:balloonCanvas|
		balloonCanvas transformBy: self transform.
		balloonCanvas aaLevel: self smoothing.
		self drawCharactersOn: balloonCanvas.
	].! !

!TTSampleFontMorph methodsFor: 'geometry' stamp: 'ar 11/14/1998 22:53'!
extent: extentPoint
	super extent: extentPoint.
	transform := nil.! !

!TTSampleFontMorph methodsFor: 'accessing' stamp: 'sma 1/1/2000 18:08'!
font
	^ font! !

!TTSampleFontMorph methodsFor: 'accessing' stamp: 'ar 11/15/1998 00:31'!
font: aTTFontDescription
	| morph |
	font := aTTFontDescription.
	morph := (TTSampleStringMorph font: font).
	morph extent: morph extent * 2.
	morph color: Color magenta.
	self addMorphCentered: morph.
	morph position: morph position x @ (self bounds bottom + 10).
	self privateFullMoveBy: self fullBounds origin negated.! !

!TTSampleFontMorph methodsFor: 'connectors' stamp: 'nk 8/17/2003 11:34'!
fontWithoutString: aTTFontDescription
	font := aTTFontDescription.
! !

!TTSampleFontMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 21:42'!
getSmoothingLevel
	"Menu support"
	smoothing = 1
		ifTrue: [^ 'turn on smoothing' translated].
	smoothing = 2
		ifTrue: [^ 'more smoothing' translated].
	smoothing = 4
		ifTrue: [^ 'turn off smoothing' translated]! !

!TTSampleFontMorph methodsFor: 'connectors' stamp: 'nk 8/17/2003 11:43'!
glyphAt: position
	^font at: (self glyphIndexAt: position).! !

!TTSampleFontMorph methodsFor: 'connectors' stamp: 'nk 8/17/2003 11:54'!
glyphIndexAt: position
	| offset |
	offset := (position adhereTo: (bounds insetBy: 1)) - bounds origin.
	offset := (offset asFloatPoint / bounds extent) * 16.
	offset := offset truncated.
	^offset y * 16 + offset x! !

!TTSampleFontMorph methodsFor: 'initialization' stamp: 'alain.plantec 5/28/2009 11:10'!
initialize
	"initialize the state of the receiver"
	super initialize.
	smoothing := 4.
	self extent: 300 @ 300! !

!TTSampleFontMorph methodsFor: 'rotate scale and flex' stamp: 'ar 11/15/1998 22:42'!
newTransformationMorph
	^MatrixTransformMorph new! !

!TTSampleFontMorph methodsFor: 'menu' stamp: 'sma 1/1/2000 17:51'!
nextSmoothingLevel
	smoothing = 1
		ifTrue: [smoothing := 2]
		ifFalse: [smoothing = 2
			ifTrue: [smoothing := 4]
			ifFalse: [smoothing = 4
				ifTrue: [smoothing := 1]]].
	self changed! !

!TTSampleFontMorph methodsFor: 'initialize' stamp: 'alain.plantec 6/1/2008 23:07'!
open
	self openInWorld! !

!TTSampleFontMorph methodsFor: 'initialization' stamp: 'alain.plantec 6/1/2008 23:08'!
openInWorld
	HandMorph attach: self! !

!TTSampleFontMorph methodsFor: 'geometry' stamp: 'ar 11/14/1998 22:53'!
position: pos
	super position: pos.
	transform := nil.! !

!TTSampleFontMorph methodsFor: 'connectors' stamp: 'nk 7/15/2003 15:12'!
printOn: aStream
	aStream nextPutAll: 'TTSampleFont(';
		nextPutAll: font familyName;
		nextPut: $)! !

!TTSampleFontMorph methodsFor: 'private' stamp: 'ar 11/14/1998 22:55'!
privateMoveBy: delta
	super privateMoveBy: delta.
	transform := nil.! !

!TTSampleFontMorph methodsFor: 'connectors' stamp: 'nk 8/17/2003 12:12'!
selectGlyph
	| retval done |
	"Modal glyph selector"
	done := false.
	self on: #mouseDown send: #selectGlyphBlock:event:from: to: self withValue: [ :glyph | retval := glyph. done := true. ].
	self on: #keyStroke send: #value to: [ done := true ].
	[ done ] whileFalse: [ self world doOneCycle ].
	self on: #mouseDown send: nil to: nil.
	self on: #keyStroke send: nil to: nil.
	^retval! !

!TTSampleFontMorph methodsFor: 'connectors' stamp: 'nk 8/17/2003 11:58'!
selectGlyphAndSendTo: aBlock
	self on: #mouseDown send: #selectGlyphBlock:event:from: to: self withValue: aBlock.! !

!TTSampleFontMorph methodsFor: 'connectors' stamp: 'nk 8/17/2003 12:17'!
selectGlyphBlock: aBlock event: evt from: me
	aBlock value: (self glyphAt: evt position).
! !

!TTSampleFontMorph methodsFor: 'accessing' stamp: 'sma 1/1/2000 17:53'!
smoothing
	^ smoothing! !

!TTSampleFontMorph methodsFor: 'accessing' stamp: 'bf 10/18/1999 16:19'!
smoothing: aNumber
	smoothing := aNumber.
	self changed! !

!TTSampleFontMorph methodsFor: 'accessing' stamp: 'ar 11/14/1998 22:53'!
transform
	^transform ifNil:[self computeTransform].! !

!TTSampleFontMorph methodsFor: 'copying' stamp: 'sma 2/26/2000 19:20'!
veryDeepFixupWith: deepCopier
	"If fields were weakly copied, fix them here. If they were in the 
	tree being copied, fix them up, otherwise point to the originals!!!!"

	super veryDeepFixupWith: deepCopier.
	font := deepCopier references at: font ifAbsent: [font]! !

!TTSampleFontMorph methodsFor: 'copying' stamp: 'sma 2/26/2000 19:18'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all,
	but shared. Warning!!!! Every instance variable defined in this class
	must be handled.  We must also implement veryDeepFixupWith:.
	See DeepCopier class comment."

	super veryDeepInner: deepCopier.
	"font := font"
	transform := transform veryDeepCopyWith: deepCopier.
	smoothing := smoothing veryDeepCopyWith: deepCopier! !

TTSampleFontMorph subclass: #TTSampleStringMorph
	instanceVariableNames: 'string ttBounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!TTSampleStringMorph commentStamp: 'VeronicaUquillas 6/11/2010 13:40' prior: 0!
I allow the display of a string in a TrueType font as a stand-alone morph.

Morph's color changes the inside of the characters.
Morph's borderColor changes the outline.

Many free fonts are stored at www.FontGuy.com.  
Use a normal web browser (not our Scamper) and go there.  
Choose 'categories' and browse to a font you like.  
Hold the mouse down on the example text in that font.  
When the menu comes up, choose "Copy this link location".  
Come back into Pharo, choose "load font from web..."
from my menu, and paste in the url.!

!TTSampleStringMorph methodsFor: 'menus' stamp: 'SvenVanCaekenberghe 7/8/2011 16:35'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'edit contents...' translated action: #edit.
	aCustomMenu add: 'how to find more fonts...' translated action: #howTo! !

!TTSampleStringMorph methodsFor: 'halos and balloon help' stamp: 'ar 11/14/1998 23:44'!
addOptionalHandlesTo: aHalo box: box! !

!TTSampleStringMorph methodsFor: 'private' stamp: 'nice 3/5/2010 22:41'!
computeTransform
	| cy |
	cy := bounds origin y + bounds corner y * 0.5.
	transform := MatrixTransform2x3 
			transformFromLocal: (ttBounds insetBy: borderWidth negated)
			toGlobal: bounds.
	transform := transform composedWithGlobal:(MatrixTransform2x3 withOffset: 0 @ cy negated).
	transform := transform composedWithGlobal:(MatrixTransform2x3 withScale: 1.0 @ -1.0).
	transform := transform composedWithGlobal:(MatrixTransform2x3 withOffset: 0 @ cy).
	^transform! !

!TTSampleStringMorph methodsFor: 'geometry testing' stamp: 'dgd 2/22/2003 14:42'!
containsPoint: aPoint 
	"^ super containsPoint: aPoint"

	"so much faster..."

	| picker |
	(self bounds containsPoint: aPoint) ifFalse: [^false].
	picker := BalloonCanvas on: (Form extent: 1 @ 1 depth: 32).
	picker transformBy: (MatrixTransform2x3 withOffset: aPoint negated).
	self drawOn: picker.
	^(picker form bits first) ~= 0! !

!TTSampleStringMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:40'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 0! !

!TTSampleStringMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:31'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ {Color magenta. Color yellow. Color orange. Color lightGray} atRandom! !

!TTSampleStringMorph methodsFor: 'drawing' stamp: 'nice 1/5/2010 15:59'!
drawOn: aCanvas
	| xStart |
	(font isNil or:[string isNil or:[string isEmpty]]) 
		ifTrue:[^aCanvas frameRectangle: bounds color: Color black].
	xStart := 0.
	aCanvas asBalloonCanvas preserveStateDuring:[:balloonCanvas|
		balloonCanvas transformBy: self transform.
		balloonCanvas aaLevel: self smoothing.
		string do:[:char| | glyph |
			glyph := font at: char.
			balloonCanvas preserveStateDuring:[:subCanvas|
				subCanvas transformBy: (MatrixTransform2x3 withOffset: xStart@0).
				subCanvas 
					drawGeneralBezierShape: glyph contours
					color: color 
					borderWidth: borderWidth 
					borderColor: borderColor].
			xStart := xStart + glyph advanceWidth.
		].
	].! !

!TTSampleStringMorph methodsFor: 'menus' stamp: 'DamienCassou 9/29/2009 13:13'!
edit
	"Allow the user to change the text in a crude way"

	| str |
	str :=  UIManager default request: 'Type in new text for this TrueType displayer.' translated
				 initialAnswer: 'some text'.
	str isEmptyOrNil ifTrue: [^ self].
	self string: str.
! !

!TTSampleStringMorph methodsFor: 'accessing' stamp: 'tk 12/10/2001 16:21'!
font: aTTFontDescription
	font := aTTFontDescription.
	string ifNil: [self string: aTTFontDescription fullName]
		ifNotNil: [self initializeString].! !

!TTSampleStringMorph methodsFor: 'menus' stamp: 'VeronicaUquillas 6/11/2010 13:40'!
howTo

	self inform: 'Many free fonts are stored at www.FontGuy.com.  
Use a normal web browser (not our Scamper) and go there.  
Choose ''categories'' and browse to a font you like.  
Hold the mouse down on the example text in that font.  
When the menu comes up, choose "Copy this link location".  
Come back into Pharo, choose "load font from web..."
from this menu, and paste in the url.'! !

!TTSampleStringMorph methodsFor: 'initialize' stamp: 'sma 1/1/2000 18:08'!
initializeString
	| xStart char glyph |
	(font isNil or: [string isNil]) ifTrue: [^ self].
	xStart := 0.
	ttBounds := 0@0 corner: 0@0.
	1 to: string size do:
		[:i |
		char := string at: i.
		glyph := font at: char.
		ttBounds := ttBounds quickMerge: (glyph bounds translateBy: xStart@0).
		xStart := xStart + glyph advanceWidth.
	].
	self extent: ttBounds extent // 40.
	borderWidth := ttBounds height // 40! !

!TTSampleStringMorph methodsFor: 'printing' stamp: 'nk 7/15/2003 15:12'!
printOn: aStream
	aStream nextPutAll: 'TTSampleString(';
		nextPutAll: font familyName;
		nextPut: $)! !

!TTSampleStringMorph methodsFor: 'accessing' stamp: 'sma 1/1/2000 18:08'!
string
	^ string! !

!TTSampleStringMorph methodsFor: 'accessing' stamp: 'ar 11/14/1998 23:53'!
string: aString
	string := aString.
	self initializeString.! !

!MorphicUIManager methodsFor: '*Deprecated14' stamp: 'StephaneDucasse 9/7/2011 21:26'!
multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: answerHeight
	"Create a multi-line instance of me whose question is queryString with
	the given initial answer. Invoke it centered at the given point, and
	answer the string the user accepts.  Answer nil if the user cancels.  An
	empty string returned means that the ussr cleared the editing area and
	then hit 'accept'.  Because multiple lines are invited, we ask that the user
	use the ENTER key, or (in morphic anyway) hit the 'accept' button, to 
	submit; that way, the return key can be typed to move to the next line."
	self deprecated: 'Use multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: ' on: '7 September 2011' in: 'Pharo1.4'.
	(ProvideAnswerNotification signal: queryString) ifNotNil: [:answer |
		^answer == #default ifTrue: [defaultAnswer] ifFalse: [answer]].
	^( self theme 
		textEditorIn: self modalMorph
		text: queryString
		title: 'Information Required' translated
		entryText: defaultAnswer
		entryHeight: answerHeight)
			ifNotNil: [:text | text asString]! !

!MorphicUIManager methodsFor: '*Deprecated14' stamp: 'IgorStasenko 4/15/2011 17:28'!
openComparisionFrom: targetMethodSource
					to: originalMethodSource
					belongingTo: aClass
					from: aChange 
					labeled: aLabel 
					inWindowLabeled: aWindowLabel 
	| diffMorph diffBuilder difference win |
	PolymorphSystemSettings usePolymorphDiffMorph 
		ifTrue:[ ^ self openPolymorphComparisonFrom: originalMethodSource 
					to: targetMethodSource
					belongingTo: aClass
					from: aChange
					labeled: aLabel
					inWindowLabeled: aWindowLabel   ].
	diffBuilder :=  TextDiffBuilder
			from: originalMethodSource 
			to: targetMethodSource.
	difference := diffBuilder buildDisplayPatch.
	win := Smalltalk tools workspace openContents: difference.
	win label: aLabel.
					
				! !

TextComposer subclass: #MultiTextComposer
	instanceVariableNames: 'presentation presentationLines'
	classVariableNames: ''
	poolDictionaries: 'TextConstants'
	category: 'Deprecated14'!

!MultiTextComposer methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 9/15/2011 17:15'!
composeEachRectangleIn: rectangles

	| myLine lastChar |

	1 to: rectangles size do: [:i | 
		currCharIndex <= theText size ifFalse: [^false].
		myLine := scanner 
			composeFrom: currCharIndex 
			inRectangle: (rectangles at: i)				
			firstLine: isFirstLine 
			leftSide: i=1 
			rightSide: i=rectangles size.
		lines addLast: myLine.
		actualHeight := actualHeight max: myLine lineHeight.  "includes font changes"
		currCharIndex := myLine last + 1.
		lastChar := theText at: myLine last.
		(CharacterSet crlf includes: lastChar) ifTrue: [^#cr].
		wantsColumnBreaks ifTrue: [
			lastChar = TextComposer characterForColumnBreak ifTrue: [^#columnBreak].
		].
	].
	^false! !

!MultiTextComposer methodsFor: '*deprecated14' stamp: 'yo 1/23/2003 12:53'!
getPresentationInfo

	^ Array with: presentationLines with: presentation.
! !

!MultiTextComposer methodsFor: '*deprecated14' stamp: 'AlainPlantec 9/15/2011 13:53'!
presentation
	^ presentation! !

!MultiTextComposer methodsFor: '*deprecated14' stamp: 'AlainPlantec 9/15/2011 13:53'!
presentationLines
	^ presentationLines! !

!TTFontDescription methodsFor: '*Deprecated14' stamp: 'MarcusDenker 2/29/2012 13:13'!
asMorph
	self  deprecated: 'dead code' on: '29 February 2012' in: 'Pharo1.4'.
	^TTSampleFontMorph font: self! !

!UITheme methodsFor: '*Deprecated14' stamp: 'AlainPlantec 10/20/2010 00:33'!
decorateMenu: aMenu 
	"decorate aMenu with icons"

	| maxWidth |
	self settings menuWithIcons ifFalse: [^ self].
	maxWidth := 10.

	aMenu items do: [:item | 
		item icon isNil ifTrue: [
			| icon | 
			icon := self iconForMenuItem: item.
			icon isNil ifFalse: [
				item icon:  icon.
				maxWidth := maxWidth max: item icon width.
			]
		]
		ifFalse: [
			item icon:  item icon.
			maxWidth := maxWidth max: item icon width
		].

		item hasSubMenu ifTrue: [
			self decorateMenu: item subMenu.
		].
	].

	maxWidth isZero ifFalse: [
		aMenu addBlankIconsIfNecessary: (self blankIconOfWidth: maxWidth).
	].
! !

!UITheme methodsFor: '*Deprecated14' stamp: 'AlainPlantec 10/19/2010 21:46'!
iconForMenuItem: anItem
	"Answer the icon (or nil) corresponding to the (translated) string."
	| itemKey |
	itemKey := anItem contents asString asLowercase.
	^ (self menuIcons detect: [:cpl | cpl key includes: itemKey] ifNone: [])
		ifNotNil: [:assoc | assoc value].
! !

!UITheme methodsFor: '*Deprecated14' stamp: 'SeanDeNigris 11/30/2011 14:30'!
menuIcons
	"answer a collection of associations wordings -> icon
	to decorate the menus all over the image"
	
	^ { 
	#('select' ) -> self smallSelectIcon.
	#('Tools...' ) -> self smallOpenIcon.
	#('System...' ) -> self smallConfigurationIcon.
	#('open...' ) -> self smallOpenIcon.
	#('windows...' ) -> self smallWindowIcon.
	#('debug...' ) -> self smallDebugIcon.
	#('export...' ) -> self smallExportIcon.
	#('save' ) -> self smallSaveIcon.
	#('save project on file...' ) -> self smallPublishIcon.
	#('save as...' 'save as new version' ) -> self smallSaveAsIcon.
	#('quit' 'save and quit' ) -> self smallQuitIcon.
	#('load project from file...' ) -> self smallLoadProjectIcon.
	""
	#('do it (d)' ) -> self smallDoItIcon.
	#('inspect it (i)' 'explore it (I)' 'inspect world' 'explore world' 'inspect model' 'inspect morph' 'explore morph' 'inspect owner chain' 'explore' 'inspect' 'explore (I)' 'inspect (i)' 'basic inspect' ) -> self smallInspectItIcon.
	#('print it (p)' ) -> self smallPrintIcon.
	#('debug it (D)' ) -> self smallDebugIcon.
	#('profile it' ) -> self blankIcon.
	""
	#('copy (c)' 'copy to paste buffer' 'copy text' ) -> self smallCopyIcon.
	#('paste (v)' 'paste...' ) -> self smallPasteIcon.
	#('cut (x)' ) -> self smallCutIcon.
	""
	#('accept (s)' 'yes' 'Yes' ) -> self smallOkIcon.
	#('cancel (l)' 'no' 'No' ) -> self smallCancelIcon.
	""
	#('do again (j)' ) -> self smallRedoIcon.
	#('undo (z)' ) -> self smallUndoIcon.
	""
	#('find...(f)' 'find again (g)' 'find class... (f)' 'find method...' 'extended search...') -> self smallFindIcon.
	""
	#('remove' 'remove class (x)' 'delete method from changeset (d)' 'remove method from system (x)' 'delete class from change set (d)' 'remove class from system (x)' 'destroy change set (X)' ) -> self smallDeleteIcon.
	#('add item...' 'new category...' 'new change set... (n)' ) -> self smallNewIcon.
	""
	#('new morph...' 'objects (o)' ) -> self smallObjectCatalogIcon.
	#('authoring tools...')  -> self smallAuthoringToolsIcon.
	""
	#('leftFlush' ) -> self smallLeftFlushIcon.
	#('rightFlush' ) -> self smallRightFlushIcon.
	#('centered' 'set alignment... (u)' ) -> self smallCenteredIcon.
	#('justified' ) -> self smallJustifiedIcon.
	""
	#('set font... (k)' 'list font...' 'set subtitles font' 'change font' 'system fonts...' 'change font...' ) -> self smallFontsIcon.
	#(StandardFonts  systemFontLabels)-> self smallFontsIcon.
	#('fullscreen on' 'fullscreen off' ) -> self smallFullscreenIcon.
	}
! !

!ScriptLoader methodsFor: '*deprecated14' stamp: 'AlainPlantec 9/13/2011 21:11'!
removeDejaVuFonts
	"Note, you need to close all windows to make the Deja Vu fonts being GCed"
	"Now that DejaVu is the only font: don't remove it!!"

	true ifTrue: [^self].

	StandardFonts setDefaultFonts: #(
		(defaultFont: 'Accuny' 10)
		(codeFont: 'Accuny' 10)
		(listFont: 'Accuny' 10)
		(menuFont: 'Accuny' 10)
		(windowTitleFont: 'Accuny' 10)
		(balloonFont: 'Accuny' 10)
		(buttonFont: 'Accuny' 10)).
	TextSharedInformation removeKey: 'Bitmap DejaVu Sans'! !

!Gofer methodsFor: '*Deprecated14' stamp: 'SeanDeNigris 8/31/2011 14:20'!
addPackage: aString
	self deprecated: 'Instead of #addPackage: simply use #package:' on: '14 December 2009' in: 'Pharo1.2'.
	self package: aString! !

!Gofer methodsFor: '*Deprecated14' stamp: 'SeanDeNigris 8/31/2011 14:20'!
addPackage: aString constraint: aBlock
	self
		deprecated: 'Instead of #addPackage:constraint: simply use #package:constraint:'
		on: '14 December 2009'
		in: 'Pharo1.2'.
	self package: aString constraint: aBlock! !

!Gofer methodsFor: '*Deprecated14' stamp: 'SeanDeNigris 8/31/2011 14:20'!
addVersion: aString
	self deprecated: 'Instead of #addVersion: simply use #version:' on: '14 December 2009' in: 'Pharo1.2'.
	self version: aString! !

!FSReference methodsFor: '*Deprecated14' stamp: 'SeanDeNigris 8/31/2011 14:20'!
childDirectories
	"Return all the directories (as opposed to files) contained in the receiver"

	self deprecated: 'Use directories' on: '29 March 2011' in: 'Pharo1.4'.
	^ self directories! !

!FSReference methodsFor: '*Deprecated14' stamp: 'SeanDeNigris 8/31/2011 14:20'!
childFiles
	"Return the direct children (files and folders) of the receiver."

	self deprecated: 'Use files instead' on: '11 February 2011' in: 'Pharo1.4'.
	^ self files! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'IgorStasenko 1/22/2012 14:37'!
basicInspect: anObject
	"Open an inspector on the given object. The tool set must know which inspector type to use for which object - the object cannot possibly know what kind of inspectors the toolset provides."
	
	self deprecated: 'Use Smalltalk tools basicInspector openOn: ... instead' on: '22 January 2012' in: 'Pharo1.4'.
	self using: #basicInspector do: [:tool | tool openOn: anObject	]! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'StephaneDucasse 10/15/2011 21:13'!
browse: aClass selector: aSelector
	"Open a browser"
	self deprecated: 'Use Smalltalk tools browser then a specific protocol like fullOnClass:selector:' on: '15 October 2011' in: 'Pharo1.4'.
	self using: #browser do: [:tool |
		tool fullOnClass: aClass selector: aSelector
	]! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'BernardoContreras 1/18/2012 22:07'!
browseChangeSetsWithClass: aClass selector: aSelector
	"Browse all the change sets with the given class/selector"
	self deprecated: 'Use Smalltalk tools changeSorter then a specific protocol like browseChangeSetsWithClass:selector:' on: '18 January 2012' in: 'Pharo1.4'.
	self using: #changeSorter do: [:tool |
		^ tool browseChangeSetsWithClass: aClass selector: aSelector ]
! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'BernardoContreras 1/18/2012 22:57'!
browseHierarchy: aClass selector: aSelector
	"Open a browser"
	self deprecated: 'Use Smalltalk tools browser then a specific protocol like  setClass:selector:  and spawnHierarchy' on: '18 January 2012' in: 'Pharo1.4'.
	
	(aClass == nil)  ifTrue: [^ self].
	
	self using: #browser do: [:tool | | newBrowser |
		(newBrowser := tool new) setClass: aClass selector: aSelector.
		newBrowser spawnHierarchy ]
! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'BernardoContreras 1/18/2012 23:05'!
browseMessageList: messageList name: title autoSelect: autoSelectString
	"Open a message set browser"
	self deprecated: 'Use Smalltalk tools messageList then a specific protocol like openMessageList:name:autoSelect:' on: '18 January 2012' in: 'Pharo1.4'.
	
	^ self using: #messageList do: [:tool |
		tool 
			openMessageList: messageList 
			name: title 
			autoSelect: autoSelectString ]	! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'BernardoContreras 1/19/2012 00:10'!
browseMessageNames: aString
	self deprecated: 'Use Smalltalk tools messageNames then a specific protocol like methodBrowserSearchingFor:' on: '18 January 2012' in: 'Pharo1.4'.
	self using: #messageNames do: [:tool | 
		^ (tool methodBrowserSearchingFor: aString) openInWorld
		]
! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'StephaneDucasse 9/17/2011 11:46'!
browseMessageSet: messageList name: title autoSelect: autoSelectString
	"Open a message set browser"
	self deprecated: 'Use browserMessageList' on:  '17 September 2011' in:  'Pharo1.4'.
	
	^ self using: #messageList do: [:tool |
		tool 
			openMessageList: messageList 
			name: title 
			autoSelect: autoSelectString ]	! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'BernardoContreras 1/19/2012 00:11'!
browseSendersOf: aSymbol name: titleString autoSelect: autoSelectString
	self deprecated: 'Use Smalltalk tools messageList then a specific protocol like openMessageList:name:autoSelect:' on: '18 January 2012' in: 'Pharo1.4'.
	^self 
		browseMessageList: (SystemNavigation default allCallsOn: aSymbol) asSortedCollection
		name: titleString 
		autoSelect: autoSelectString! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'BernardoContreras 1/19/2012 20:40'!
browseVersionsOf: aClass selector: aSelector
	"Open a browser"
	self deprecated: 'Use Smalltalk tools versionBrowser then a specific protocol like browseVersionsOf:class:meta:category:selector:' on: '19 January 2012' in: 'Pharo1.4'.
	self using: #versionBrowser do: [:tool | 
		tool
			browseVersionsOf: (aClass compiledMethodAt: aSelector)
			class: aClass theNonMetaClass
			meta: aClass isMeta
			category: (aClass organization categoryOfElement: aSelector)
			selector: aSelector ]! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'BernardoContreras 1/22/2012 16:53'!
debug: aProcess context: aContext label: aString contents: contents fullView: aBool
	"Open a debugger on the given process and context."
	self deprecated: 'Use Smalltalk tools debugger then a specific protocol like openOn:context:label:contents:fullView:' on: '22 January 2012' in: 'Pharo1.4'.
	self using: #debugger do: [:tool |
		^ tool 
			openOn: aProcess 
			context: aContext 
			label: aString 
			contents: contents 
			fullView: aBool ]! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'BernardoContreras 1/22/2012 16:57'!
debugContext: aContext label: aString contents: contents
	"Open a debugger on the given process and context."
	self deprecated: 'Use Smalltalk tools debugger then a specific protocol like openContext:label:contents:' on: '22 January 2012' in: 'Pharo1.4'.
	self using: #debugger do: [:tool |
		^ tool openContext: aContext label: aString contents: contents
		]! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'IgorStasenko 1/22/2012 14:43'!
explore: anObject
	"Open an explorer on the given object."
	self deprecated: 'Use Smalltalk tools objectExplorer openOn: ... instead' on: '22 January 2012' in: 'Pharo1.4'.

	self objectExplorer openOn: anObject
! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'IgorStasenko 1/22/2012 14:46'!
exploreViewHierarchy: aMorph
	"Open an explorer on the given object."
	self deprecated: 'UseSmalltalk tools viewHierarchyExplorer openOn: ... instead' on: '22 January 2012' in: 'Pharo1.4'.

	^ self viewHierarchyExplorer openOn: aMorph! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'BernardoContreras 1/22/2012 17:01'!
interrupt: aProcess label: aString
	"Open a debugger on the given process and context."
	self deprecated: 'Use Smalltalk tools debugger then a specific protocol like openInterrupt:onProcess:' on: '22 January 2012' in: 'Pharo1.4'.
	self using: #debugger do: [:tool | 
		tool openInterrupt: aString onProcess: aProcess
		]
! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'StephaneDucasse 9/17/2011 11:35'!
messageSet
	self deprecated: 'Message Set does not exist anymore use MessageList' on:  '17 September 2011' in: 'Pharo1.4'.
	^MessageList! !

!ToolRegistry methodsFor: '*deprecated14' stamp: 'BernardoContreras 1/19/2012 20:59'!
openClassListBrowser: anArray title: aString
	"Open a class list browser"
	self deprecated: 'Use Smalltalk tools classListBrowser then a specific protocol like initForClassesNamed:title:' on: '19 January 2012' in: 'Pharo1.4'.
	self using: #classListBrowser do: [:tool |
		^ tool new initForClassesNamed: anArray title: aString
		]
! !

!UserInputEvent methodsFor: '*deprecated14' stamp: 'StephaneDucasse 7/22/2011 16:31'!
leftShiftDown
	"Answer true if the shift key on the keyboard was being held down when this event occurred."
	
	self deprecated: 'Use shiftPressed' on:  '22 July 2011' in: #Pharo1.4.
	^ self shiftPressed
! !

MessageSet subclass: #MessageNames
	instanceVariableNames: 'searchString selectorList selectorListIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!MessageNames commentStamp: 'BernardoContreras 8/14/2011 00:52' prior: 0!
DEPRECATED. see http://code.google.com/p/pharo/issues/detail?id=4576.!

!MessageNames class methodsFor: '*Deprecated14' stamp: 'BernardoContreras 8/14/2011 00:47'!
methodBrowserSearchingFor: searchString
	"Answer an method-browser window whose search-string is initially as indicated"

	| aWindow |
	self deprecated: 'issue 4576' on: '14 August, 2011' in: 'Pharo1.4'.
	aWindow := self new inMorphicWindowWithInitialSearchString: searchString.
	aWindow applyModelExtent.
	^ aWindow! !

!MessageNames class methodsFor: '*Deprecated14' stamp: 'BernardoContreras 8/14/2011 00:48'!
openMessageNames
	"Open a new instance of the receiver in the active world"

	self deprecated: 'issue 4576' on: '14 August, 2011' in: 'Pharo1.4'.	
	self new openAsMorphNamed: 'Message Names' inWorld: self currentWorld

	"MessageNames openMessageNames"
! !

!MessageNames class methodsFor: 'window color' stamp: 'AlainPlantec 12/16/2009 22:09'!
patchworkUIThemeColor
	"Answer a default color for UI themes that make use of different colors for Browser, MessageList etc..."

	^ Color fromRgbTriplet: #(0.645 1.0 0.452) ! !

!MessageNames class methodsFor: 'tools registry' stamp: 'IgorStasenko 2/19/2011 03:02'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 

	registry register: self as: #messageNames
! !

!MessageNames methodsFor: 'search' stamp: 'LucFabresse 10/1/2010 16:08'!
computeSelectorListFromSearchString
	"Compute selector list from search string"
	
	self searchString: (searchString asString copyWithout: Character arrowUp).
	selectorList := Cursor wait showWhile: [
					(SystemNavigation default allImplementedMessages select: [:each | each  includesSubstring: searchString caseSensitive: false]) asArray sort: [:x :y | x asLowercase <= y asLowercase]].
	^ selectorList! !

!MessageNames methodsFor: 'message list menu' stamp: 'sd 11/20/2005 21:27'!
copyName
	"Copy the current selector to the clipboard"

	| selector |
	(selector := self selectorList at: selectorListIndex ifAbsent: [nil]) ifNotNil:
		[Clipboard clipboardText: selector asString asText]! !

!MessageNames methodsFor: 'search' stamp: 'GaryChambers 7/5/2010 13:28'!
doSearchFrom: aTextMorph
	"The user hit the Search button -- treat it as a synonym for the user having hit the Return or Enter (or cmd-s) in the type-in pane"

	aTextMorph
		accept;
		changed! !

!MessageNames methodsFor: 'initialization' stamp: 'sw 7/28/2001 02:16'!
inMorphicWindowLabeled: labelString
	"Answer a morphic window with the given label that can display the receiver"
"MessageNames openMessageNames"

	^ self inMorphicWindowWithInitialSearchString: nil! !

!MessageNames methodsFor: 'initialization' stamp: 'JuanVuletich 10/22/2010 09:13'!
inMorphicWindowWithInitialSearchString: initialString
	"Answer a morphic window with the given initial search string, nil if none"

"MessageNames openMessageNames"

	^UIManager default messageNames: self inMorphicWindowWithInitialSearchString: initialString! !

!MessageNames methodsFor: 'selector list' stamp: 'StephaneDucasse 5/28/2011 13:34'!
messageList
	"Answer the receiver's message list, computing it if necessary. The way 
	to force a recomputation is to set the messageList to nil"
	messageList
		ifNil: [messageList := selectorListIndex = 0
						ifTrue: [#()]
						ifFalse: [self systemNavigation
								allImplementorsOf: (selectorList at: selectorListIndex)].
			self
				messageListIndex: (messageList size > 0
						ifTrue: [1]
						ifFalse: [0])].
	^ messageList! !

!MessageNames methodsFor: 'search' stamp: 'GaryChambers 7/5/2010 12:57'!
searchString
	"Answer the current searchString, initializing it if need be"

	^ searchString ifNil: [searchString := '']! !

!MessageNames methodsFor: 'accessing' stamp: 'LucFabresse 10/1/2010 15:56'!
searchString: aStringToSearch
	searchString := aStringToSearch! !

!MessageNames methodsFor: 'search' stamp: 'JuanVuletich 10/22/2010 10:12'!
searchString: aString from: aTextMorph
	"Take what the user typed and find all selectors containing it"

	aTextMorph selectAll.
	searchString := aString asString copyWithout: $ .
	self containingWindow ifNotNil: [ :w | w setLabel: ('Message names containing "{1}"' translated format: {searchString asLowercase}) ].
	selectorList := nil.
	self changed: #selectorList.
	self changed: #messageList.
	^true! !

!MessageNames methodsFor: 'selection' stamp: 'MarcusDenker 8/15/2010 10:57'!
selectedMessageName
	^selectorListIndex = 0 ifFalse: [selectorList at: selectorListIndex]! !

!MessageNames methodsFor: 'selection' stamp: 'sw 7/24/2001 01:46'!
selection
	"Answer the item in the list that is currently selected, or nil if no selection is present"

	^ self messageList at: messageListIndex ifAbsent: [nil]! !

!MessageNames methodsFor: 'selector list' stamp: 'sd 11/20/2005 21:27'!
selectorList
	"Answer the selectorList"

	selectorList ifNil:
		[self computeSelectorListFromSearchString.
		selectorListIndex :=  selectorList size > 0
			ifTrue:	[1]
			ifFalse: [0].
		messageList := nil].
	^ selectorList! !

!MessageNames methodsFor: 'selector list' stamp: 'sw 7/24/2001 01:55'!
selectorListIndex
	"Answer the selectorListIndex"

	^ selectorListIndex! !

!MessageNames methodsFor: 'selector list' stamp: 'AlainPlantec 11/13/2009 22:59'!
selectorListIndex: anInteger 
	"Set the selectorListIndex as specified, and propagate consequences"

	selectorListIndex := anInteger.
	selectorListIndex = 0
		ifTrue: [^ self].
	messageList := nil.
	self changed: #selectorListIndex.
	self changed: #messageList.
	self changed: #annotation.! !

!MessageNames methodsFor: 'initialization' stamp: 'sw 7/24/2001 01:35'!
selectorListKey: aChar from: view
	"Respond to a Command key in the message-list pane."

	aChar == $n ifTrue: [^ self browseSenders].
	aChar == $c ifTrue: [^ self copyName].
	aChar == $b ifTrue: [^ self browseMethodFull].
! !

!MessageNames methodsFor: 'initialization' stamp: 'tbn 7/29/2010 21:56'!
selectorListMenu: aMenu
	"Answer the menu associated with the selectorList"

	aMenu addList: {
		{'Senders (n)' translated. #browseSenders. 'Browse senders of the chosen selector' translated}.
		{'Copy selector to clipboard' translated. #copyName. 'Copy the chosen selector to the clipboard, for subsequent pasting elsewhere' translated}.
		#-.
		{'Show only implemented selectors' translated. #showOnlyImplementedSelectors. 'Remove from the selector-list all symbols that do not represent implemented methods' translated}}.

	^ aMenu! !

!MessageNames methodsFor: 'selector list' stamp: 'sw 7/24/2001 01:47'!
selectorListMenuTitle
	"Answer the title to supply for the menu belonging to the selector-list pane"

	^ 'Click on any item in the list
to see all implementors of it'! !

!MessageNames methodsFor: 'search' stamp: 'sd 11/20/2005 21:27'!
showOnlyImplementedSelectors
	"Caution -- can be slow!! Filter my selector list down such that it only  
	shows selectors that are actually implemented somewhere in the system."
	self okToChange
		ifTrue: [Cursor wait
				showWhile: [selectorList := self systemNavigation allSelectorsWithAnyImplementorsIn: selectorList.
					self changed: #selectorList.
					self changed: #messageList]]! !

!TPureBehavior methodsFor: '*Deprecated14' stamp: 'MarcusDenker 2/28/2012 18:24'!
sourceMethodAt: selector 
	"Answer the paragraph corresponding to the source code for the 
	argument."
	self deprecated: 'use sourceCodeAt:'  on: ' 28 February 2012'  in: 'Pharo 1.4'.
	^(self sourceCodeAt: selector) asText makeSelectorBoldIn: self! !

!TPureBehavior methodsFor: '*Deprecated14' stamp: 'MarcusDenker 2/28/2012 18:26'!
sourceMethodAt: selector ifAbsent: aBlock
	"Answer the paragraph corresponding to the source code for the 
	argument."
	self deprecated: 'use sourceCodeAt:'  on: ' 28 February 2012'  in: 'Pharo 1.4'.
	^ (self sourceCodeAt: selector ifAbsent: [^ aBlock value]) asText makeSelectorBoldIn: self! !

PolygonMorph subclass: #MixedCurveMorph
	instanceVariableNames: 'slopeClamps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!MixedCurveMorph commentStamp: '<historical>' prior: 0!
A MixedCurveMorph is Curve that can be broken up into separately curved segments. It allows for the creation of matching edges( e. g. for jigsaw puzzle pieces).

Instance Variables
	slopeClamps:		<Array>

slopeClamps
	- elements of array are either 0 or nil. Indicating whether slope for the corresponding vertex is 0@0 or unknown and therefore to be calculated. There is one element for each vertex.
	
	
!

!MixedCurveMorph methodsFor: 'access' stamp: 'StephaneDucasse 6/5/2011 16:12'!
clamps
	"Return a collection of clamps the same size as vertices.
	If necessary default to unclamped slopes."

	slopeClamps 
		ifNil:   [ ^ slopeClamps := Array new: vertices size  ] .
	slopeClamps size = vertices size
		ifFalse: [ ^ slopeClamps := Array new: vertices size  ] . 
	^ slopeClamps           ! !

!MixedCurveMorph methodsFor: 'editing' stamp: 'StephaneDucasse 6/5/2011 16:12'!
clickVertex: ix event: evt fromHandle: handle
	"Toggle the state of the clamp."
	"Note: self clamps assures slopeClamps will be same size as vertices"

	(self clamps at: ix) 
		ifNil: [ slopeClamps  at: ix put: 0 ]
		ifNotNil: [ slopeClamps  at: ix put: nil ].
	self setVertices: vertices.
	
! !

!MixedCurveMorph methodsFor: 'editing' stamp: 'StephaneDucasse 6/5/2011 16:13'!
deleteVertexAt: anIndex
	(slopeClamps :=
				slopeClamps
				copyReplaceFrom: anIndex
				to: anIndex
				with: Array new) .
	self setVertices: (vertices
				copyReplaceFrom: anIndex
				to: anIndex
				with: Array new).
				! !

!MixedCurveMorph methodsFor: 'access' stamp: 'StephaneDucasse 6/5/2011 16:12'!
handleColorAt: vertIndex
      "Clamped handles are cyan and unclamped handles are yellow."

	(self clamps at: vertIndex ) ifNil: [ ^ Color yellow ].
	^ Color cyan 
! !

!MixedCurveMorph methodsFor: 'initialization' stamp: 'StephaneDucasse 6/5/2011 16:13'!
initialize
	"initialize the state of the receiver"
	
	super initialize.
	self extent: 32@20 .

	self rectOval.
	self clamps . "This initializes slopeClamps."
	slopeClamps at: 1 put: 0 .
	slopeClamps at: 4 put: 0 .
	
	closed := true.
	smoothCurve := true.
	arrows := #none.
	self computeBounds! !

!MixedCurveMorph methodsFor: 'editing' stamp: 'StephaneDucasse 6/5/2011 16:13'!
insertVertexAt: anIndex put: aValue
	"New vertexs are unclamped."
	"Note: order is important. 
	The clamps array must match vertex size before setVertices: is performed."
	slopeClamps := slopeClamps  copyReplaceFrom: anIndex + 1 to: anIndex with: (Array with: nil).
	self setVertices: (vertices copyReplaceFrom: anIndex + 1 to: anIndex 
									with: (Array with: aValue)).! !

!MixedCurveMorph methodsFor: 'smoothing' stamp: 'StephaneDucasse 6/5/2011 16:13'!
slopes: knots 
	"Choose slopes according to state of polygon and preferences"
	
	self isCurvy
		ifFalse: [^ knots segmentedSlopes].
	^ (closed and: [ self isCurvier ])
		ifTrue: [ knots closedCubicSlopes: self clamps ]
		ifFalse: [ knots naturalCubicSlopes: self clamps ]! !

Form subclass: #FormStub
	instanceVariableNames: 'locator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!FormStub methodsFor: 'accessing' stamp: 'ar 2/24/2001 22:02'!
locator
	^locator! !

!FormStub methodsFor: 'accessing' stamp: 'ar 2/24/2001 22:02'!
locator: aString
	locator := aString! !

RectangleMorph subclass: #BalloonRectangleMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!BalloonRectangleMorph commentStamp: '<historical>' prior: 0!
BalloonRectangleMorph is an example for drawing using the BalloonEngine.!

!BalloonRectangleMorph methodsFor: 'testing' stamp: 'ar 8/25/2001 19:08'!
canDrawBorder: aBorderStyle
	^aBorderStyle style == #simple! !

!BalloonRectangleMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:33'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ GradientFillStyle ramp: {0.0 -> Color black. 1.0 -> Color white}! !

!BalloonRectangleMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:36'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 10! !

!BalloonRectangleMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:24'!
defaultColor
	"answer the default color/fill style for the receiver"
	| result |
	result := GradientFillStyle ramp: {0.0 -> Color green. 0.5 -> Color yellow. 1.0 -> Color red}.
	result radial: true.
	^ result! !

!BalloonRectangleMorph methodsFor: 'accessing' stamp: 'ar 11/15/1998 22:24'!
doesBevels
	"To return true means that this object can show bevelled borders, and
	therefore can accept, eg, #raised or #inset as valid borderColors.
	Must be overridden by subclasses that do not support bevelled borders."

	^ false! !

!BalloonRectangleMorph methodsFor: 'drawing' stamp: 'ar 11/15/1998 22:40'!
drawOn: aCanvas
	(color isKindOf: OrientedFillStyle) ifTrue:[
		color origin: bounds center.
		color direction: (bounds extent x * 0.7) @ 0.
		color normal: 0@(bounds extent y * 0.7).
	].
	(borderColor isKindOf: OrientedFillStyle) ifTrue:[
		borderColor origin: bounds topLeft.
		borderColor direction: (bounds extent x) @ 0.
		borderColor normal: 0@(bounds extent y).
	].
	aCanvas asBalloonCanvas
		drawRectangle: (bounds insetBy: borderWidth // 2)
		color: color
		borderWidth: borderWidth
		borderColor: borderColor.! !

!BalloonRectangleMorph methodsFor: 'initialization' stamp: 'MarcusDenker 12/11/2009 23:55'!
initialize
	"initialize the state of the receiver"
	super initialize.
	self extent: 100@100! !

!BalloonRectangleMorph methodsFor: 'rotate scale and flex' stamp: 'ar 11/15/1998 22:20'!
newTransformationMorph
	^MatrixTransformMorph new! !

!InputEventSensor methodsFor: '*Deprecated14' stamp: 'StephaneDucasse 7/22/2011 16:31'!
leftShiftDown
	"Answer whether the shift key on the keyboard is being held down. The name of this message is a throwback to the Alto, which had independent left and right shift keys."

	self deprecated: 'Use shiftPressed' on:  '22 July 2011' in: #Pharo1.4.
	^ self shiftPressed! !

!InputEventSensor methodsFor: '*Deprecated14' stamp: 'MarcusDenker 3/3/2012 23:57'!
peekMousePt
	self deprecated: 'use asMCMethodDefinition' on: '3 March 2012' in: 'Pharo 1.4'.
	^ mousePosition! !

!FSFilesystem methodsFor: '*Deprecated14' stamp: 'StephaneDucasse 7/3/2011 16:07'!
working
	self deprecated: 'Use workingDirectory' on:  '4 Juillet 2011' in: 'Pharo1.4'.
	^ self referenceTo: self workingDirectory! !

!RunArray methodsFor: '*Deprecated14' stamp: 'MarcusDenker 3/5/2012 20:55'!
addLast: value times: times
	"Add value as the last element of the receiver, the given number of times"
	self deprecated: 'use add:withOccurrences:' on: '5 March 2012' in: 'Pharo 1.4'.
	^self add: value withOccurrences: times! !

!NonInteractiveUIManager methodsFor: '*Deprecated14' stamp: 'StephaneDucasse 9/7/2011 21:27'!
multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: answerHeight
	self deprecated: 'Use multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: ' on: '7 September 2011' in: 'Pharo1.4'.
	^ self nonInteractive! !

!SystemWindow class methodsFor: '*Deprecated14' stamp: 'MarcusDenker 3/2/2012 00:06'!
fullScreenMargin
	self deprecated: 'use fullscreenMargin' on: ' 2 March 2012' in: 'Pharo 1.4'.
	^self fullscreenMargin.! !

!SystemWindow class methodsFor: '*Deprecated14' stamp: 'MarcusDenker 3/2/2012 00:06'!
fullScreenMargin: anInteger
	self deprecated: 'use fullscreenMargin:' on: ' 2 March 2012' in: 'Pharo 1.4'.
	^self fullscreenMargin: anInteger.! !

Object subclass: #BuiltinSettingStyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!BuiltinSettingStyle commentStamp: 'AlainPlantec 9/14/2011 14:34' prior: 0!
A BuiltinSettingStyle provides a mean to store the state of all system settings according to specific user preferences and/or to some particular using (demonstration style with big fonts, laptop/desktop used at home or at work ...). The only behavior of a style is implemented by its load method. Thus, a style can be loaded programmatically as follow:
------------------
MyStyle new loadStyle
------------------
Where MyStyle is a subclass of BuiltinSettingStyle which can implement a load method as below:
------------------
MyStyle>>load
	"load change a set of settings with some prefered value"
	MorphicSettings haloEnabled value: true.
	...
------------------
So, a style is simply a class with a loadStyle method. In order for a style class to be recognized as such by the setting browser, a class method #styleName must be implemented as follow:
------------------
styleName
	<settingstyle>
	^ 'My cool style'
------------------
This method must be tagged with the pragma	<settingstyle> and returns the name of the style.
!

!BuiltinSettingStyle class methodsFor: 'accessing' stamp: 'AlainPlantec 9/17/2011 18:34'!
allStyleClasses
	^ ((((PragmaCollector
		filter: [:prag | prag keyword = 'settingStyle']) reset collected
		collect: [:p | p methodClass theNonMetaClass])
		reject: [:c | c = BuiltinSettingStyle]) asArray sort: [:a :b | a styleName < b styleName]) asOrderedCollection! !

!BuiltinSettingStyle class methodsFor: 'accessing' stamp: 'AlainPlantec 9/14/2011 14:50'!
styleName
	"The style name used by the SettingBrowser
	must be redefined with the <settingStyle> pragma by subclasses"
	^ self subclassresponsibility ! !

!BuiltinSettingStyle methodsFor: 'loading' stamp: 'AlainPlantec 9/14/2011 14:29'!
load
	"assign a particular value to a set of preferences.
	Subclasses may redefine it for a particular style (i.e. demo style)"
	SettingBrowser refreshAllSettingBrowsers
! !

!BuiltinSettingStyle methodsFor: 'loading' stamp: 'StephaneDucasse 11/20/2011 15:32'!
loadStyle
	[self load]
		on: Error
		do: [:ex | self traceCr: ex printString.
			self traceCr: 'Error while loading Setting style ' , self class styleName.
			^ false].
	self traceCr:  'Setting style ' , self class styleName , ' loaded.'.
	^ true! !

BuiltinSettingStyle subclass: #DefaultSettingStyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!DefaultSettingStyle commentStamp: 'AlainPlantec 9/14/2011 14:45' prior: 0!
A DefaultSettingStyle represents the default system style with mainly the default theme and the default fonts and sizes

Instance Variables
!

!DefaultSettingStyle class methodsFor: 'accessing' stamp: 'AlainPlantec 9/14/2011 14:52'!
styleName
	<settingStyle>
	^ 'Default'! !

!DefaultSettingStyle methodsFor: 'loading' stamp: 'SeanDeNigris 11/28/2011 21:53'!
load
	SystemBrowser default: Browser.
	CodeHolder browseWithPrettyPrint: false.
	CodeHolder showAnnotationPane: false.
	ChangeSet mustCheckForSlips: true.
	CodeHolder diffsInChangeList: true.
	CodeHolder diffsWithPrettyPrint: false.
	TextEditor caseSensitiveFinds: false.
	Editor blinkingCursor: true.
	Editor dumbbellCursor: false.
	TextEditor walkAlongDisplayedLine: true.
	CodeHolder smartUpdating: true.
	Parser warningAllowed: false.
	Parser allowBlockArgumentAssignment: false.
	Scanner allowUnderscoreAsAssignment: false.
	Deprecation raiseWarning: true.
	Deprecation showWarning: true.
	UserInterruptHandler cmdDotEnabled: true.
	CPUWatcher cpuWatcherEnabled: false.
	WorldState debugShowDamage: false.
	Debugger logDebuggerStackToFile: true.
	Debugger restartAlsoProceeds: false.
	Debugger alwaysOpenFullDebugger: false.
	ObjectExplorer showIcons: true.
	Debugger logFileName: 'PharoDebug.log'.
	DialogItemsChooserUI alreadySearchedUnselectedItemsListMaxSize: 15.
	DialogItemsChooserUI alreadySearchedSelectedItemsListMaxSize: 15.
	TextDiffBuilder ignoreLineEndings: true.
	Display fullscreen: false.
	FinderUI searchedTextListMaxSize: 15.
	FreeTypeSettings current monitorType: #LCD.
	FreeTypeSettings updateFontsAtImageStartup: false.
	FreeTypeCache current cacheSize: 5000.
	FreeTypeSettings current hintingSymbol: #Light.
	FreeTypeSettings current glyphContrast: 50.0.
	InputEventSensor controlAltKeyDecodePolicy: #FullMatching.
	LongTestCase shouldRun: true.
	MCCodeTool showAnnotationPane: false.
	NetworkSystemSettings useHTTPProxy: false.
	NonInteractiveUIManager snapshotErrorImage: false.
	PSMCPatchMorph usedByDefault: true.
	RealEstateAgent usedStrategy: #staggerFor:initialExtent:world:.
	SystemWindow fullscreenMargin: 25.
	TextEntryDialogWindow minimumWidth: 450.
	HaloMorph haloEnclosesFullBounds: false.
	HaloMorph showBoundsInHalo: false.
	UITheme currentAnimationSettings useAnimation: false.
	UITheme currentAnimationSettings animateClosing: false.
	UITheme currentAnimationSettings delay: 8.
	UITheme currentAnimationSettings numberOfSteps: 20.
	MorphicModel keyboardFocusOnMouseDown: true.
	MorphicModel mouseOverForKeyboardFocus: false.
	PluggableTextMorph showTextEditingState: true.
	StringMorph editableStringMorph: false.
	Morph defaultYellowButtonMenuEnabled: false.
	WorldState easySelectingWorld: false.
	PolymorphSystemSettings usePolymorphDiffMorph: true.
	PolymorphSystemSettings showDesktopLogo: true.
	PolymorphSystemSettings desktopLogoFileName: ''.
	PolymorphSystemSettings desktopColor: (Color r: 0.937 g: 0.937 b: 0.937).
	PolymorphSystemSettings useDesktopGradientFill: false.
	SoundService soundEnabled: false.
	RBProgramNode formatterClass: RBConfigurableFormatter.
	RecentMessageList uniqueInstance maxListSize: 0.
	RecentMessageList uniqueInstance useAsASet: false.
	RefactoryChangeManager undoSize: 20.
	SHPreferences enabled: true.
	WorldState serverMode: false.
	SmalltalkImage checkSourcesFileAvailability: true.
	SmalltalkImage checkChangesFileAvailability: true.
	Locale activated: false.
	TasklistMorph keepOpen: false.
	TaskbarMorph showTaskbar: true.
	TaskbarMorph showWindowPreview: true.
	
	StandardFonts setFontsToSmall.
	UITheme standardThemeClass beCurrent.
	UITheme current resetDefaultSettings.

	super load.
! !

BuiltinSettingStyle subclass: #DemoSettingStyle
	instanceVariableNames: ''
	classVariableNames: 'BaseFontSize'
	poolDictionaries: ''
	category: 'Deprecated14'!

!DemoSettingStyle commentStamp: 'AlainPlantec 12/31/2010 11:34' prior: 0!
A DemoSettingStyle is a predefined style for demonstrations with bigger fonts.
!

!DemoSettingStyle class methodsFor: 'accessing' stamp: 'AlainPlantec 9/14/2011 14:52'!
styleName
	<settingStyle>
	^ 'Demo Style'! !

!DemoSettingStyle methodsFor: 'loading' stamp: 'AlainPlantec 9/14/2011 18:10'!
load
	| k |
	k := StrikeFont defaultFontKey.
	StandardFonts setFontsFromSpec: {
			{#defaultFont:. k. 24 }. 
			{#codeFont:. k. 24 }.
			{#listFont:. k. 24 }. 
			{#menuFont:. k. 24 }. 
			{#windowTitleFont:. k. 14 }. 
			{#balloonFont:. k. 14 }. 
			{#haloFont:. k.  14}.
			{#buttonFont:. k. 24 } }.
			
	PolymorphSystemSettings desktopColor: (Color r: 0.893 g: 0.97 b: 0.993).
	PolymorphSystemSettings useDesktopGradientFill: true.
	PolymorphSystemSettings desktopGradientFillColor: (Color r: 0.026000000000000002 g: 0.362 b: 0.446).
	PolymorphSystemSettings desktopGradientDirection: #Radial.
	PolymorphSystemSettings desktopGradientOrigin: #topLeft.

	super load.

! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:35'!
checkHaltCountExpired

	self deprecated: 'Was used internally by Object>>halt:onCount: See its deprecation warning' on: '8/29/2011' in: '1.4'.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:56'!
clearHaltOnce
	"Turn on image-wide Halt once"

	self deprecated: 'Use "Halt disableHaltOnce". This method bloats Object and wrongly suggests haltOnce may be per-object' on: '8/29/2011' in: '1.4'.
	Halt disableHaltOnce.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:36'!
decrementAndCheckHaltCount

	self deprecated: 'Was used internally by Object>>halt:onCount: See its deprecation warning' on: '8/29/2011' in: '1.4'.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:36'!
decrementHaltCount

	self deprecated: 'Was used internally by Object>>halt:onCount: See its deprecation warning' on: '8/29/2011' in: '1.4'.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:36'!
doExpiredHaltCount

	self deprecated: 'Was used internally by Object>>halt:onCount: See its deprecation warning' on: '8/29/2011' in: '1.4'.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:35'!
doExpiredHaltCount: aString

	self deprecated: 'Was used internally by Object>>halt:onCount: See its deprecation warning' on: '8/29/2011' in: '1.4'.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:57'!
halt: aString onCount: anInteger 
	"Deprecated: see below
	Halt on the anInteger-th time through, showing message aString"
		
	| currentCount |
	currentCount := Halt isCounting 
		ifTrue: [ Halt callsUntilHaltOnCount ]
		ifFalse: [
				self deprecated: 'Use #haltOnCount:. Since you end up in a debugger, aString provides little information' on: '8/29/2011' in: '1.4'.
				anInteger ].
	Halt callsUntilHaltOnCount: currentCount - 1.
	Halt callsUntilHaltOnCount = 0 ifTrue: [ Halt now ].! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:36'!
haltCount

	self deprecated: 'Was used internally by Object>>halt:onCount: See its deprecation warning' on: '8/29/2011' in: '1.4'.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:57'!
haltOnce: aString 
	"Halt unless we have already done it once."

	self deprecated: 'Use #haltOnce:. Since you end up in a debugger, aString provides little information' on: '8/29/2011' in: '1.4'.
	Halt isHaltOnceEnabled
		ifTrue: [ Halt disableHaltOnce.
				^ Halt signal: aString ]! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:57'!
haltOnceEnabled
	"is haltOnce enabled globally"

	self deprecated: 'Use "Halt isHaltOnceEnabled".  This method bloats Object and wrongly suggests haltOnce may be per-object' on: '8/29/2011' in: '1.4'.
	^ Halt isHaltOnceEnabled.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 15:51'!
hasHaltCount

	self deprecated: 'Now private to Halt' on: '8/29/2011' in: '1.4'.
	^ Halt isCounting.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 15:51'!
removeHaltCount

	self deprecated: 'Now private to Halt' on: '8/29/2011' in: '1.4'.
	^ Halt stopCounting.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:55'!
setHaltCountTo: int

	self deprecated: 'Was used internally by Object>>halt:onCount: See its deprecation warning' on: '8/29/2011' in: '1.4'.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:58'!
setHaltOnce
	"Turn on the halt once flag."

	self deprecated: 'Use "Halt enableHaltOnce".  This method bloats Object and wrongly suggests haltOnce may be per-object' on: '8/29/2011' in: '1.4'.
	Halt enableHaltOnce.! !

!Object methodsFor: '*deprecated14' stamp: 'SeanDeNigris 8/29/2011 17:34'!
toggleHaltOnce

	self deprecated: 'See Halt for new API' on: '8/29/2011' in: '1.4'.
	Halt isHaltOnceEnabled
		ifTrue: [Halt disableHaltOnce]
		ifFalse: [Halt enableHaltOnce]! !

Object subclass: #SourceReference
	instanceVariableNames: 'timeStamp timeStampString sourcePointer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

SourceReference subclass: #MethodReference
	instanceVariableNames: 'classIsMeta classSymbol methodSymbol stringVersion category package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!MethodReference commentStamp: 'Ben 10/23/2010 15:13' prior: 0!
A MethodReference is is a lightweight proxy for a CompiledMethod.  Has methods for pointed to the CompileMethod's source statements, byte codes. Is heavily used my Tools.

Instance Variables
	classIsMeta:		     Boolean class vs. instance
	classSymbol:		Symbol for method's class (without class keyword if meta)
	methodSymbol:		Symbol for method's selector
	stringVersion:		'Class>>selector:' format

!

!MethodReference class methodsFor: 'instance creation' stamp: ''!
class: aClass selector: aSelector
	"Changed to support inheritance"
	^ self new setStandardClass: aClass methodSymbol: aSelector! !

!MethodReference class methodsFor: 'Package' stamp: ''!
class: aClass selector: aSelector package: aPackage

	^ (self class: aClass selector: aSelector ) package: aPackage ; yourself! !

!MethodReference methodsFor: 'comparisons' stamp: ''!
<= anotherMethodReference

	classSymbol < anotherMethodReference classSymbol ifTrue: [^true].
	classSymbol > anotherMethodReference classSymbol ifTrue: [^false].
	classIsMeta = anotherMethodReference classIsMeta ifFalse: [^classIsMeta not].
	^methodSymbol <= anotherMethodReference methodSymbol
! !

!MethodReference methodsFor: 'comparisons' stamp: ''!
= anotherMethodReference 
	"Answer whether the receiver and the argument represent the 
	same object."
	^ self species == anotherMethodReference species
		and: [(self classSymbol = anotherMethodReference classSymbol)
				and: [(self classIsMeta = anotherMethodReference classIsMeta)
						and: [self methodSymbol = anotherMethodReference methodSymbol]]]! !

!MethodReference methodsFor: 'accessing' stamp: 'StephaneDucasse 12/26/2011 17:39'!
actualClass
	| actualClass traitName |
	self deprecated: 'use RGMethodDefinition' on: '8 October 2011'  in: 'Pharo1.4'.
	('*classTrait' match: classSymbol)
		ifTrue: [ 
			traitName := classSymbol copyUpTo: Character space.
			^ Smalltalk globals at: traitName asSymbol ifAbsent: [ nil ] ].
	actualClass := Smalltalk globals at: classSymbol ifAbsent: [ ^ nil ].
	classIsMeta
		ifTrue: [ ^ actualClass classSide ].
	^ actualClass! !

!MethodReference methodsFor: 'traits' stamp: 'MarcusDenker 3/24/2011 14:50'!
argumentNames
	"Return an array with the argument names of the method's selector"

	| keywords stream argumentNames delimiters |
	delimiters := {Character space. Character cr}.
	keywords := self selector keywords.
	stream := self source readStream.
	argumentNames := OrderedCollection new.
	keywords do: [ :each | | argumentName |
		stream match: each.
		[stream peekFor: Character space] whileTrue.
		argumentName := ReadWriteStream on: String new.
		[(delimiters includes: stream peek) or: [stream peek isNil]]
			whileFalse: [argumentName nextPut: stream next].
		argumentName isEmpty ifFalse: [
			argumentNames add: argumentName contents withBlanksTrimmed]].
	^(argumentNames copyFrom: 1 to: self method numArgs) asArray! !

!MethodReference methodsFor: 'accessing' stamp: 'VeronicaUquillas 8/23/2011 12:05'!
asMCMethodDefinition
	self flag: 'should be removed as soon as MethodReference is not used anymore'.
	^ MCMethodDefinition forMethodReference: self! !

!MethodReference methodsFor: '*Deprecated14' stamp: 'MarcusDenker 3/3/2012 23:58'!
asMethodDefinition
	self deprecated: 'use asMCMethodDefinition' on: '3 March 2012' in: 'Pharo 1.4'.
	^ MCMethodDefinition forMethodReference: self! !

!MethodReference methodsFor: 'queries' stamp: 'MarcusDenker 4/24/2011 10:01'!
asStringOrText
	| text |
	self actualClass ifNil: [ ^stringVersion ].
	text := (self stringVersion,' {',self category asString,'} ') asText.
	self isLocalSelector ifFalse: [ text addAttribute: TextEmphasis italic ].
	^ text! !

!MethodReference methodsFor: 'queries' stamp: ''!
category
	^ category ifNil: [category := self actualClass organization categoryOfElement: methodSymbol]! !

!MethodReference methodsFor: 'string version' stamp: ''!
category: aString
	
	 category := aString! !

!MethodReference methodsFor: 'queries' stamp: ''!
classIsMeta

	^classIsMeta! !

!MethodReference methodsFor: 'accessing' stamp: 'StephaneDucasse 12/26/2011 17:39'!
className
	self deprecated: 'use RGMethodDefinition' on: '8 October 2011'  in: 'Pharo1.4'.
	^classSymbol! !

!MethodReference methodsFor: 'queries' stamp: ''!
classSymbol

	^classSymbol! !

!MethodReference methodsFor: 'accessing' stamp: 'StephaneDucasse 12/26/2011 17:39'!
classSymbol: aSymbol
	self deprecated: 'use RGMethodDefinition' on: '8 October 2011'  in: 'Pharo1.4'.
	classSymbol := aSymbol! !

!MethodReference methodsFor: 'accessing' stamp: 'StephaneDucasse 12/26/2011 17:39'!
compiledMethod
	self deprecated: 'use RGMethodDefinition' on: '8 October 2011'  in: 'Pharo1.4'.
	^ self actualClass compiledMethodAt: methodSymbol ! !

!MethodReference methodsFor: 'comparisons' stamp: ''!
hash
	"Answer a SmallInteger whose value is related to the receiver's  
	identity."
	^ (self species hash bitXor: self classSymbol hash)
		bitXor: self methodSymbol hash! !

!MethodReference methodsFor: 'traits' stamp: 'MarcusDenker 3/24/2011 14:51'!
isBinarySelector
	^self selector
		allSatisfy: [:each | each isSpecial]! !

!MethodReference methodsFor: 'testing' stamp: ''!
isLocalSelector
	^self actualClass
		includesLocalSelector: self methodSymbol! !

!MethodReference methodsFor: 'queries' stamp: ''!
isValid
	"Answer whether the receiver represents a current selector or Comment"

	| aClass |
	methodSymbol isDoIt ifTrue: [^ false].
	(aClass := self actualClass) ifNil: [^ false].
	^ (aClass includesSelector: methodSymbol) or:
		[methodSymbol == #Comment]! !

!MethodReference methodsFor: 'accessing' stamp: 'StephaneDucasse 12/26/2011 17:39'!
location
	self deprecated: 'use RGMethodDefinition' on: '8 October 2011'  in: 'Pharo1.4'.
	^ self actualClass ! !

!MethodReference methodsFor: 'accessing' stamp: 'StephaneDucasse 12/26/2011 17:40'!
method
	self deprecated: 'use RGMethodDefinition' on: '8 October 2011'  in: 'Pharo1.4'.
	^ self compiledMethod! !

!MethodReference methodsFor: 'accessing' stamp: 'StephaneDucasse 12/26/2011 17:40'!
methodClass
	self deprecated: 'use RGMethodDefinition' on: '8 October 2011'  in: 'Pharo1.4'.
	^ self actualClass ! !

!MethodReference methodsFor: 'queries' stamp: ''!
methodSymbol

	^methodSymbol! !

!MethodReference methodsFor: 'queries' stamp: 'StephaneDucasse 8/9/2011 18:05'!
methodSymbol: aSymbol

	methodSymbol := aSymbol! !

!MethodReference methodsFor: 'accessing' stamp: 'StephaneDucasse 12/26/2011 17:40'!
package
	"we will have to change that in the future since we will not rely on * convention"
	self deprecated: 'use RGMethodDefinition' on: '8 October 2011'  in: 'Pharo1.4'.
	^ package! !

!MethodReference methodsFor: 'accessing' stamp: 'StephaneDucasse 12/26/2011 17:40'!
package: aPackage
	self deprecated: 'use RGMethodDefinition' on: '8 October 2011'  in: 'Pharo1.4'.
	package := aPackage! !

!MethodReference methodsFor: 'queries' stamp: ''!
printOn: aStream
	"Print the receiver on a stream"

	super printOn: aStream.
	aStream nextPutAll: ' ', self actualClass name, ' >> #', methodSymbol! !

!MethodReference methodsFor: 'accessing' stamp: 'StephaneDucasse 12/26/2011 17:40'!
realClass
	self deprecated: 'use RGMethodDefinition' on: '8 October 2011'  in: 'Pharo1.4'.
	^ self actualClass ! !

!MethodReference methodsFor: 'accessing' stamp: 'StephaneDucasse 12/26/2011 17:40'!
selector
	self deprecated: 'use RGMethodDefinition' on: '8 October 2011'  in: 'Pharo1.4'.
	^methodSymbol! !

!MethodReference methodsFor: 'accessing' stamp: 'StephaneDucasse 12/26/2011 17:40'!
selector: aSymbol
	self deprecated: 'use RGMethodDefinition' on: '8 October 2011'  in: 'Pharo1.4'.
	methodSymbol := aSymbol! !

!MethodReference methodsFor: 'setting' stamp: ''!
setClass: aClass methodSymbol: methodSym

	classSymbol := aClass theNonMetaClass name.
	classIsMeta := aClass isMeta.
	methodSymbol := methodSym.
	stringVersion := aClass name , ' ' , methodSym.! !

!MethodReference methodsFor: 'setting' stamp: ''!
setClass: aClass methodSymbol: methodSym stringVersion: aString 

	classSymbol := aClass theNonMetaClass name.
	classIsMeta := aClass isMeta.
	methodSymbol := methodSym.
	stringVersion := aString.! !

!MethodReference methodsFor: 'setting' stamp: ''!
setClassAndSelectorIn: csBlock

	^csBlock value: self actualClass value: methodSymbol! !

!MethodReference methodsFor: 'setting' stamp: ''!
setClassSymbol: classSym classIsMeta: isMeta methodSymbol: methodSym stringVersion: aString 

	classSymbol := classSym.
	classIsMeta := isMeta.
	methodSymbol := methodSym.
	stringVersion := aString.! !

!MethodReference methodsFor: 'setting' stamp: 'Sd 11/2/2010 12:49'!
setStandardClass: aClass methodSymbol: methodSym

	classSymbol := aClass theNonMetaClass name.
	classIsMeta := aClass isMeta.
	methodSymbol := methodSym.
	stringVersion := aClass name , ' ' , methodSym.! !

!MethodReference methodsFor: 'accessing' stamp: 'StephaneDucasse 12/26/2011 17:40'!
source
	self deprecated: 'use RGMethodDefinition' on: '8 October 2011'  in: 'Pharo1.4'.
	^ (self actualClass sourceCodeAt: methodSymbol) asString withSqueakLineEndings! !

!MethodReference methodsFor: 'accessing' stamp: 'ab 5/23/2003 22:58'!
sourceCode
	^ self actualClass sourceCodeAt: methodSymbol! !

!MethodReference methodsFor: 'queries' stamp: ''!
sourceString
	^ (self actualClass sourceCodeAt: self methodSymbol) asString! !

!MethodReference methodsFor: 'string version' stamp: ''!
stringVersion	
	^stringVersion.! !

!MethodReference methodsFor: 'string version' stamp: ''!
stringVersion: aString

	stringVersion := aString! !

!MethodReference methodsFor: 'string version' stamp: ''!
stringVersionDefault

	^classSymbol, (classIsMeta ifTrue: [ ' class ' ] ifFalse: [' ']), methodSymbol  ! !

!MethodReference methodsFor: 'accessing' stamp: 'StephaneDucasse 12/26/2011 17:40'!
timeStamp
	self deprecated: 'use RGMethodDefinition' on: '8 October 2011'  in: 'Pharo1.4'.
	^ self compiledMethod timeStamp! !

!SourceReference methodsFor: 'comparing' stamp: 'JohanBrichau 1/21/2011 12:07'!
<= aSourceReference
	"Sort source references according to: 1. class - 2. class comment - 3. class/instance methods - 4. method selector - 5. timestamp"
	
	self classSymbol < aSourceReference classSymbol ifTrue: [^true].
	self classSymbol > aSourceReference classSymbol ifTrue: [^false].
	aSourceReference isCommentReference ifTrue:[^false].
	self isCommentReference ifTrue:[^ true].
	self isClassMethodReference = aSourceReference isClassMethodReference ifFalse: [^self isClassMethodReference not].
	^ self methodSymbol = aSourceReference methodSymbol 
		ifTrue:[true]
		ifFalse:[self timeStamp <= aSourceReference timeStamp]! !

!SourceReference methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/8/2012 17:10'!
browse

	^ self subclassResponsibility! !

!SourceReference methodsFor: 'accessing' stamp: ''!
date
	"return the date when the method was modified"
	^ self timeStamp asDate! !

!SourceReference methodsFor: 'private' stamp: ''!
fileIndex
	^SourceFiles fileIndexFromSourcePointer: self sourcePointer! !

!SourceReference methodsFor: 'private' stamp: ''!
filePosition
	^SourceFiles filePositionFromSourcePointer: self sourcePointer! !

!SourceReference methodsFor: 'private' stamp: 'StephaneDucasse 5/28/2011 13:36'!
findTimestampInSource	
		"Answer the authoring time-stamp for the given method, retrieved from the sources or changes file. Answer the empty string if no time stamp is available."	
			
	| position file preamble stamp tokens stampPosition |

	self fileIndex = 0 ifTrue: [^ String new].  "no source pointer for this method"
	position :=self filePosition.
	file := SourceFiles at: self fileIndex.
	file ifNil: [^ String new].  "sources file not available"
	"file does not exist happens in secure mode"
	"Transcript show: file ; cr."
	file := [file readOnlyCopy] 
			on: FileDoesNotExistException 
			do:[:ex| ^ String new].
	self flag: 'I do not know why 3 is a good number'.
	preamble :=  self getPreambleFrom: file at: (0 max: position - 3).
	(preamble findString: self preambleString startingAt: 1) > 0
			ifTrue: [tokens := Scanner new scanTokens: preamble.
				
				     	stampPosition := tokens indexOf: self stampSymbol.
					stampPosition = 0
						ifTrue:[stamp:= ''.]
						ifFalse: [
							"New format gives change stamp and unified prior pointer"
							stamp := tokens at: stampPosition + 1]]
			ifFalse: [" Name is already defined ->The stamp get lost, maybe after a condenseChanges"
					stamp := '' ].
	file close.
 	^ stamp! !

!SourceReference methodsFor: 'private' stamp: 'StephaneDucasse 10/20/2011 15:44'!
getPreambleFrom: aFileStream at: position
	|  writeStream |
	writeStream := String new writeStream.
	position to: 0 by: -1 do: [ :p | 
			| c | 
			aFileStream position: p.
			c := aFileStream basicNext.
			c == $!!
				ifTrue: [^ writeStream contents reversed]
				ifFalse: [writeStream nextPut: c]].
	Halt halt: 'should not arrive here'.! !

!SourceReference methodsFor: 'testing' stamp: 'JohanBrichau 1/21/2011 12:08'!
isClassMethodReference 
	^ false! !

!SourceReference methodsFor: 'testing' stamp: 'StephaneDucasse 7/26/2011 14:09'!
isComment
	^ false! !

!SourceReference methodsFor: 'testing' stamp: 'JohanBrichau 1/21/2011 12:08'!
isCommentReference 
	^ false! !

!SourceReference methodsFor: 'private' stamp: 'JohanBrichau 12/30/2010 15:05'!
parseTimestampFrom: aString
	"Parse a date-time from a timestamp-string that is extracted from a source file. If there is no timestamp, or we cannot make sense of it, we return the epoch."
	| tokens dateStartIndex |
	"The following timestamp strings are supported (source: squeak sources archeological survey):
		<authorname><date><time>. 
		<authorname><date>
		<date><time>
		<date><time><authorname>
		<date><authorname>
		<historical>
	All fields can be separated by spaces or line ends but a separator between authorname and date can be missing as well"
	
	dateStartIndex := (aString indexOf: $/) - 1. 
	"If there is no / character in the timestamp, we cannot parse a date and return the epoch"
	dateStartIndex = -1 ifTrue:[^ DateAndTime epoch].
	^ [	"Go the start of the date string (there can be 1 or 2 digits and a space separator can be missing at the front!!!!)"
		((dateStartIndex < 2) not and:[(aString at: dateStartIndex - 1) isDigit]) ifTrue:[dateStartIndex := dateStartIndex - 1].
		"Extract only those tokens that possibly represent date or time"
		tokens := (aString copyFrom: dateStartIndex to: aString size) subStrings select: [:token | (token occurrencesOf: $/) = 2 or:[(token occurrencesOf: $:) = 1]].
		"2 tokens is a datetime"
		tokens size = 2
			ifTrue:[(tokens joinUsing: Character space) asDateAndTime]
			ifFalse:[(tokens first) asDate asDateAndTime]
		] 
		on: Exception 
		do:[:e | DateAndTime epoch]! !

!SourceReference methodsFor: 'private' stamp: ''!
preambleString
	self subclassResponsibility! !

!SourceReference methodsFor: 'printing' stamp: ''!
printStringForRML
	^self subclassResponsibility! !

!SourceReference methodsFor: 'tool compatibility' stamp: 'JohanBrichau 1/21/2011 12:08'!
setClassAndSelectorIn: csBlock

	^csBlock value: self actualClass value: self methodSymbol! !

!SourceReference methodsFor: 'accessing' stamp: ''!
sourceCode
	| fileIndex filePosition |
	fileIndex := SourceFiles fileIndexFromSourcePointer: sourcePointer.
	filePosition := SourceFiles filePositionFromSourcePointer: sourcePointer.
	^ filePosition = 0 
		ifTrue: [nil]
		ifFalse:[(RemoteString newFileNumber: fileIndex position: filePosition) text]

! !

!SourceReference methodsFor: 'accessing' stamp: ''!
sourcePointer 
	^ sourcePointer! !

!SourceReference methodsFor: 'private' stamp: ''!
stampSymbol
	self subclassResponsibility! !

!SourceReference methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/8/2011 15:02'!
time
	"I'm actually the real accessor to timestamp as a TimeStamp"
	
	^ timeStamp ifNil:[timeStamp := self parseTimestampFrom: self timeStampString]! !

!SourceReference methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/8/2011 15:02'!
timeStamp
	"Should be a String"
	"If you want a Date, use date instead"
	
	^ self time asString! !

!SourceReference methodsFor: 'accessing' stamp: 'JohanBrichau 12/30/2010 12:51'!
timeStampString 
	^ timeStampString ifNil:[timeStampString := self findTimestampInSource]! !

Object subclass: #SparseXTable
	instanceVariableNames: 'tables xTables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!SparseXTable methodsFor: 'accessing' stamp: 'MarcusDenker 2/21/2012 13:29'!
tableFor: code

	| div |
	self  deprecated: 'dead code?' on: '21 February 2012' in: 'Pharo1.4'.
	div := code // 65536.
	^xTables at: div ifAbsentPut:
		[Array new: 65536 withAll: 0].
! !

Object subclass: #XTableForUnicodeFont
	instanceVariableNames: 'ranges xTables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!XTableForUnicodeFont methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 2/24/2012 16:49'!
at: indexPlusOne

	| index |
	self  deprecated: 'dead code?' on: '24 February 2012' in: 'Pharo1.4'.
	
	index := indexPlusOne.
	ranges with: xTables do: [:range :xTable |
		(range first <= index and: [index <= range last]) ifTrue: [
			^ xTable at: index - range first + 1.
		].
	].
	^ 0.
! !

!XTableForUnicodeFont methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 2/24/2012 16:49'!
at: index put: value

	self  deprecated: 'dead code?' on: '24 February 2012' in: 'Pharo1.4'.
	ranges with: xTables do: [:range :xTable |
		(range first <= index and: [index <= range last]) ifTrue: [
			^ xTable at: index - range first + 1 put: value]].
	^ 0.
! !

!XTableForUnicodeFont methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 2/24/2012 16:49'!
ranges: pairArray

	self  deprecated: 'dead code?' on: '24 February 2012' in: 'Pharo1.4'.
	xTables := Array new: 0.
	pairArray do: [:range |
		xTables := xTables copyWith: (Array new: range last - range first + 1 withAll: 0).
	].
	ranges := pairArray.
! !

!XTableForUnicodeFont methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 2/24/2012 16:49'!
size
	self  deprecated: 'dead code?' on: '24 February 2012' in: 'Pharo1.4'.
	^ ranges last last - ranges first first + 1.
! !

!DummyUIManager methodsFor: '*Deprecated14' stamp: 'StephaneDucasse 9/7/2011 21:26'!
multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: answerHeight

	self deprecated: 'Use multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: ' on: '7 September 2011' in: 'Pharo1.4'.! !

!ChangeRecord methodsFor: '*Deprecated14' stamp: 'MarcusDenker 3/3/2012 23:56'!
asMethodDefinition
	self deprecated: 'use asMCMethodDefinition' on: '3 March 2012' in: 'Pharo 1.4'.
	^ MCMethodDefinition 
		className: class
		classIsMeta: meta
		selector: self methodSelector
		category: category
		timeStamp: stamp
		source: self string! !
LogoImageMorph initialize!
